<!DOCTYPE html>

<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Colmena Player</title>
  <style type="text/css">
    ul { list-style: none; }
    li { margin: 1em; }
    audio { display: block; }
  </style>
</head>

<body>
  <h1>Decoder Example</h1>
  <p>Choose either a file from disk, or a file from a server.</p>
  <p>File is decoded to pcm buffers and then played back as Riff</p>

  <h2>Options</h2>

  <div>
    <label>Decoder output sample rate</label>
    <input id="sampleRate" type="number" value="8000" />
  </div>

  <div>
    <label>Wave file bit depth</label>
    <input id="bitDepth" type="number" value="16" />
  </div>

  <h2>Commands</h2>
  <input type="file" id="fileInput"/>
  <button type="button" id="remoteButton">Load using XMLHttpRequest</button>

  <h2>Recordings</h2>
  <ul id="recordingslist"></ul>

  <script>
    function decodeOgg(arrayBuffer){

      var typedArray = new Uint8Array(arrayBuffer);
      var decoderWorker = new Worker('dist/decoderWorker.min.js');
      var wavWorker = new Worker('dist/waveWorker.min.js');
      var desiredSampleRate = parseInt(sampleRate.value,10);

      decoderWorker.postMessage({ 
        command:'init',
        decoderSampleRate: desiredSampleRate,
        outputBufferSampleRate: desiredSampleRate
      });

      wavWorker.postMessage({ 
        command:'init',
        wavBitDepth: parseInt(bitDepth.value,10),
        wavSampleRate: desiredSampleRate
      });

      decoderWorker.onmessage = function(e){

        // null means decoder is finished
        if (e.data === null) {
          wavWorker.postMessage({ command: 'done' });
        }

        // e.data contains decoded buffers as float32 values
        else {
          wavWorker.postMessage({
            command: 'encode',
            buffers: e.data
          }, e.data.map(function(typedArray){
            return typedArray.buffer;
          }));
        }
      };

      wavWorker.onmessage = function(e){

        if (e.data.message === "page") {
          var fileName = new Date().toISOString() + ".wav";
          var dataBlob = new Blob( [ e.data.page ], { type: "audio/wav" } );
          var url = URL.createObjectURL( dataBlob );

          var audio = document.createElement('audio');
          audio.controls = true;
          audio.src = URL.createObjectURL( dataBlob );

          var link = document.createElement('a');
          link.href = url;
          link.download = fileName;
          link.innerHTML = link.download;

          var li = document.createElement('li');
          li.appendChild(link);
          li.appendChild(audio);

          recordingslist.appendChild(li);
        }
      };

      decoderWorker.postMessage({
        command: 'decode',
        pages: typedArray
      }, [typedArray.buffer] );
    };

    fileInput.onchange = function(e){
      var fileReader = new FileReader();

      fileReader.onload = function() {
        decodeOgg(this.result);
      };

      fileReader.readAsArrayBuffer( e.target.files[0] );
    };

    remoteButton.onclick = function(){
      var xhr = new XMLHttpRequest();
      xhr.open("GET", "./mono.opus", true);
      xhr.responseType = "arraybuffer";

      xhr.onload = function(e) {
        decodeOgg(this.response);
      };

      xhr.send();
    };

  </script>
</body>
</html>
